# Buffon's Needle
import random as rd
import numpy as np
import matplotlib.pyplot as plt

def plot_needles(n_needle):
  plt.figure(figsize=(14, 7))
  Lmin=0.; Lmax=3.
  topline_x=[Lmin, Lmax]
  topline_y=[1.0, 1.0]
  bottomline_x=[Lmin, Lmax]
  bottomline_y=[0, 0]
  
  plt.plot(topline_x, topline_y, 'b', linewidth=3)
  plt.plot(bottomline_x, bottomline_y, 'b', linewidth=3)
  
  center_x=np.empty(n_needle, float)
  
  for i in range(n_needle):
    center_x[i]=rd.random()*Lmax    # [0, Lmax]
    # theta global 정의
    x=[center_x[i]-np.cos(theta[i])*0.5, center_x[i]+np.cos(theta[i])*0.5]
    y=[center_y[i]-np.sin(theta[i])*0.5, center_y[i]+np.sin(theta[i])*0.5]
    plt.plot(x, y, 'r')
  plt.xlim(-0.5, 3.5)
  plt.ylim(-0.5, 1.5)
  
  ax=plt.gca()
  plt.show()

if __name__=="__main__":
  n=[10, 100, 500, 1000]
  for nn in n:
    rd.seed()
    theta=np.empty(nn, float)
    center_y=np.empty(nn, float)
    D=np.empty(nn, float)
    
    N_count=0
    for i in range(nn):
      theta[i]=np.pi*rd.random()
      center_y[i]=rd.random()
      if center_y[i]>0.5:
        D[i]=1.-center_y[i]
      else:
        D[i]=center_y[i]
      
      if D[i]<=np.sin(theta[i])/2.:
        N_count+=1
    p=N_count/nn
    print("pi=", 2.0/p)
    
    plot_needles(nn)
